import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkDeposit, ThinkDepositParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkDeposit(params: ThinkDepositParam) {
  const res = await request.get<ApiResult<PageResult<ThinkDeposit>>>(
    THINK_API_URL + '/think/think-deposit/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkDeposit(params?: ThinkDepositParam) {
  const res = await request.get<ApiResult<ThinkDeposit[]>>(
    THINK_API_URL + '/think/think-deposit',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkDeposit(data: ThinkDeposit) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-deposit',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkDeposit(data: ThinkDeposit) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-deposit',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkDeposit(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-deposit/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkDeposit(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-deposit/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkDeposit(id: number) {
  const res = await request.get<ApiResult<ThinkDeposit>>(
    THINK_API_URL + '/think/think-deposit/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
